#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# rerun: defines the layout and functions of the select rerunnable attributes
#	 dialog box.
proc rerun {} {
  global LABELFONT rerunDialogBox activeWindow selv

  busy_cursor
## Bring up the standard Dialog box ##
  set rerunDialogBox ".rerun"
  set dbox [popupDialogBox $rerunDialogBox "Select Rerunnable Attribute Criteria" 1 "" "" 1]
  set activeWindow($rerunDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m

  frame $dbox_top.c
  frame $dbox_top.c.val
  frame $dbox_top.c.dummy -relief groove -borderwidth 3

  set rbox [buildRadioboxes $dbox_top.c.val \
                { {{y y} {n n} {any "ANY (y or n)"}} } column 0 ""]
  set rerunValFrame [lindex $rbox 0]
  set rerunY [lindex $rbox 1] 
  set rerunN [lindex $rbox 2] 
  set rerunANY [lindex $rbox 3]

  $rerunY configure -variable selv(rerun_val) -value y 
  $rerunN configure -variable selv(rerun_val) -value n
  $rerunANY configure -variable selv(rerun_val) -value "ANY"

## set DEFAULT
  set rerun_arg [lindex $selv(rerun) 1]
  switch -regexp -- $rerun_arg {
    "-ANY-"       {$rerunANY invoke}
    y             {$rerunY invoke}
    n             {$rerunN invoke}
  }
## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom \
    {{{ok ok} {help help}}} x 2m 18 3]

  set cmdFrame     [lindex $cmdButtons 0]
  set cmdOk        [lindex $cmdButtons 1]
  set cmdHelp      [lindex $cmdButtons 2]

  $cmdHelp configure -command {xpbs_help select.rerun $rerunDialogBox}

  $cmdOk configure -command {
    if { [string compare $selv(rerun_val) "ANY"] == 0 } {
      set selv(rerun) "Rerunnable: -ANY-"
    } else {
      set selv(rerun) "Rerunnable: $selv(rerun_val)"
    }
    destroy $rerunDialogBox
  }

## PACK the FRAMES
  label $dbox_top.c.l -text "Rerunnable" -font $LABELFONT
  pack $dbox_top.c.val -in $dbox_top.c.dummy -padx 3 -pady 3 
  raise $dbox_top.c.val $dbox_top.c.dummy
  pack $dbox_top.c.l $dbox_top.c.dummy -side left -anchor nw -padx 5
  pack $dbox_top.header $dbox_top.c $dbox_top.footer -padx 5m
  register_default_action $rerunDialogBox $cmdOk

  tkwait visibility $rerunDialogBox
  remove_busy_cursor
  catch {tkwait window $rerunDialogBox}
  set activeWindow($rerunDialogBox) 0
}
